{# heredando header y footer #}
{% extends "./plantilla.html" %}
{% load static %}
  {% block contenido %}
    <br>
    <div class="container-fluid py-4">
      <div class="row">
        <div class="col-xl-2 col-sm-6 mb-xl-0 mb-9">
        </div>
        <div class="col-xl-10 col-sm-6 mb-xl-0 mb-9">
          <h3>REGISTRO DE CURSOS</h3>
          <br>
          <form class="" action="/guardarCurso/" method="post" enctype="multipart/form-data" id='frm_nuevo_curso'>
            {% csrf_token %}
            <div class="row">
              <div class="col-md-6">
                <b>SELECCIONE LA CARRERA</b>
                <select  name="id_carrera"  id="id_carrera" data-live-search="true" data-live-search-style="startsWith" class="selectpicker" required>
                  <option value="">-- Seleccione la carrera --</option>
                  {% for carrera in carreras %}
                  <option value="{{carrera.idCarreraGEPT}}">{{carrera.nombreCarreraGEPT}}</option>
                  {% endfor %}
                </select>
                <br>
                <br>
                <b>NIVEL:</b>
                <input type="text" name="nivelCursoGEPT" id="nivelCursoGEPT" value="" placeholder="Ingrese el nivel del curso" class="form-control" required>
                <br>
                <b>DESCRIPCION:</b>
                <textarea name="descripcionCursoGEPT" id="descripcionCursoGEPT" placeholder="Ingrese la descripcion del curso" class="form-control" required rows="8" cols="80"></textarea>
                <br><br>
              </div>
              <div class="col-md-6">
                <b>BLOQUE:</b>
                <input type="text" name="bloqueCursoGEPT" id="bloqueCursoGEPT" value="" placeholder="Ingrese el Bloque del curso" class="form-control" required>
                <br>
                <b>JORNADA:</b>
                <input type="text" name="horarioCursoGEPT" id="horarioCursoGEPT" value="" placeholder="Ingrese el Horario" class="form-control" required>
                <br>
                <b>AULA:</b>
                <input type="text" name="aulaCursoGEPT" id="aulaCursoGEPT" value="" placeholder="Ingrese el Aula" class="form-control" required>
                <br>
              </div>
            </div>
            <center>
              <button type="submit" name="button" class="btn btn-info bg-gradient-info">Guardar</button>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
              <a type="reset" name="button" class="btn btn-danger bg-gradient-danger" href="{% url 'listadoCursos' %}">Cancelar</a>
            </center>
          </form>
          <hr>
          <div class="cart-body px-0 pt-0 pb-2">
            <div class="col-md-12">
              <table class="table table-striped" id="tbl_curso" style="color: black;">
                <h3>LISTADO DE CURSOS</h3>
                <div class="d-flex justify-content-center" >
                  <img src="{% static 'img/4.jpg' %}" alt="" class="img-fluid">
                </div>
                <thead>
                  <tr>
                    <th>ID</th>
                    <th>CARRERA</th>
                    <th>NIVEL</th>
                    <th>DESCRIPCION</th>
                    <th>AULA</th>
                    <th>BLOQUE</th>
                    <th>HORARIO</th>
                    <th>ACCIONES</th>
                  </tr>
                </thead>
                <tbody>
                  {% for curso in cursos %}
                    <tr>
                      <td>{{curso.idCursoGEPT}}</td>
                      <td>{{curso.carrera.nombreCarreraGEPT}}</td>
                      <td>{{curso.nivelCursoGEPT}}</td>
                      <td>{{curso.descripcionCursoGEPT}}</td>
                      <td>{{curso.aulaCursoGEPT}}</td>
                      <td>{{curso.bloqueCursoGEPT}}</td>
                      <td>{{curso.horarioCursoGEPT}}</td>
                      <td>
                        <a href="/editarCurso/{{curso.idCursoGEPT}}" class="btn btn-warning bg-gradient-warning">Editar</a>
                        <a href="javascript:void(0)" class="btn btn-danger bg-gradient-danger" onclick="eliminarCurso('/eliminarCurso/{{curso.idCursoGEPT}}');">Eliminar</a>
                      </td>
                    </tr>
                    {% endfor %}
                </tbody>
              </table>
              <button id="toggleChartButton" onclick="toggleChart()" class="btn btn-info bg-gradient-info">Mostrar/ocultar gráfico</button>
            </div>
          </div>
      </div>
    </div>
  </div>
    <script type="text/javascript">
      function eliminarCurso(url){
        iziToast.question({
            timeout: 15000,
            close: true,
            overlay: true,
            displayMode: 'once',
            id: 'question',
            zindex: 999,
            title: 'CONFIRMACIÓN',
            message: '¿Está seguro de eliminar el curso seleccionado?',
            position: 'center',
            buttons: [
                ['<button><b>SI</b></button>', function (instance, toast) {
                    instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
                    window.location.href=url;
                }, true],
                ['<button>NO</button>', function (instance, toast) {

                    instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');

                }],
            ]
        });
      }
    </script>
    <script type="text/javascript">
      $(document).ready(function() {
        $("#frm_nuevo_curso").validate({
          rules: {
            "id_carrera": {
              required: true
            },
            "nivelCursoGEPT": {
              required: true
            },
            "descripcionCursoGEPT": {
              required: true
            },
            "aulaCursoGEPT": {
              required: true
            },
            "bloqueCursoGEPT": {
              required: true,
              lettersOnly: true
            },
            "horarioCursoGEPT": {
              required: true
            }
          },
          messages: {
            "id_carrera": {
              required: "Debe seleccionar una carrera"
            },
            "nivelCursoGEPT": {
              required: "Debe ingresar el nivel del curso"
            },
            "descripcionCursoGEPT": {
              required: "Debe ingresar una descripción del curso"
            },
            "aulaCursoGEPT": {
              required: "Debe ingresar el aula del curso"
            },
            "bloqueCursoGEPT": {
              required: "Debe ingresar el bloque del curso",
              lettersOnly: "Ingrese solo letras"
            },
            "horarioCursoGEPT": {
              required: "Debe ingresar el horario del curso"
            }
          }
        });

        // Agregar regla de método personalizado para validar solo letras
        $.validator.addMethod("lettersOnly", function(value, element) {
          return this.optional(element) || /^[a-zA-Z\s]+$/.test(value);
        }, "Ingrese solo letras");
      });
    </script>

    <script type="text/javascript">
       //let table = new DataTable('#tbl_clientes');
       $(document).ready(function() {
           $('#tbl_curso').DataTable({
               dom: 'Bfrtip',
               language: {
                 url: '//cdn.datatables.net/plug-ins/1.13.7/i18n/es-ES.json',
               },
               buttons: [
                   {
                       extend: 'pdfHtml5',
                       text: '<i class="fa fa-file-pdf-o"></i> PDF',
                       titleAttr: 'Exportar a PDF',
                       className: 'btn btn-danger bg-gradient-danger', // Clase de estilo para el botón
                       title: 'LISTADO DE LOS CURSOS'
                   },
                   {
                       extend: 'print',
                       text: '<i class="fa fa-print"></i> Imprimir',
                       titleAttr: 'Imprimir',
                       className: 'btn btn-primary bg-gradient-primary', // Clase de estilo para el botón
                       title: 'LISTADO DE LOS CURSOS'
                   },
                   {
                       extend: 'csv',
                       text: '<i class="fa fa-file-text-o"></i> CSV',
                       titleAttr: 'Exportar a CSV',
                       className: 'btn btn-success bg-gradient-success' // Clase de estilo para el botón
                   }
               ]
           });
       });

      </script>


      <div id="chartContainer" style="width: 50%; margin: auto; border: 2px solid black; padding: 10px; display: none;">
        <canvas id="myChart"></canvas>
      </div>

      <script>
          document.addEventListener('DOMContentLoaded', function () {
            const ctx = document.getElementById('myChart');

            const carrerasSet = new Set();

            const cursosCarrera = {};
            {% for curso in cursos %}
              carrerasSet.add("{{ curso.carrera.nombreCarreraGEPT }}");
              if (!cursosCarrera["{{ curso.carrera.nombreCarreraGEPT }}"]) {
                cursosCarrera["{{ curso.carrera.nombreCarreraGEPT }}"] = 1;
              } else {
                cursosCarrera["{{ curso.carrera.nombreCarreraGEPT }}"] += 1;
              }
            {% endfor %}
            const carrerasArray = Array.from(carrerasSet);
            const posiciones = carrerasArray.map((carrera, index) => ({ x: index, y: cursosCarrera[carrera] || 0 }));

            new Chart(ctx, {
              type: 'bar',
              data: {
                labels: carrerasArray,
                datasets: [{
                  label: 'Cantidad de Carreras',
                  data: posiciones.map(posicion => posicion.y),
                  backgroundColor: 'rgba(192, 248, 248)',
                  borderColor: 'rgba(192, 248, 248)',
                  borderWidth: 1,
                }]
              },
              options: {
                scales: {
                  x: {
                    type: 'category',
                    position: 'bottom',
                  },
                  y: {
                    beginAtZero: true,
                    max: 10,
                    stepSize: 1,
                  }
                }
              }
            });
            window.toggleChart = function() {
              const chartContainer = document.getElementById('chartContainer');

              if (chartContainer.style.display === 'none') {
                chartContainer.style.display = 'block';
              } else {
                chartContainer.style.display = 'none';
              }
            };
          });

      </script>
  {% endblock %}
